/* (c)2013 ALTIMESH & HighPerformanceComputing Magazine - All rights reserved */

#include <cstdio>
#include <cstdlib>
#include <immintrin.h>
#include <sys/time.h>
#include <cmath>

#ifdef __MIC__
__attribute__((target(mic))) inline
#endif
float myexpm1 (float x)
{
	float res = x + 8.0f ;
	res = res * x + 56.0f ;
	res = res * x + 336.0f ;
	res = res * x + 1680.0f ;
	res = res * x + 6720.0f ;
	res = res * x + 20160.0f ;
	return res * x * 2.4801587301587301587301587301587e-5f ;
}

#ifdef __MIC__
__attribute__((target(mic))) inline
#endif
double myexpm1d (double x)
{
	double res = x + 8.0 ;
	res = res * x + 56.0 ;
	res = res * x + 336.0 ;
	res = res * x + 1680.0 ;
	res = res * x + 6720.0 ;
	res = res * x + 20160.0 ;
	return res * x * 2.4801587301587301587301587301587e-5 ;
}

#pragma offload_attribute(push,target(mic))
#define declareconst(name,value) static const __m512 name = {value,value,value,value,value,value,value,value,value,value,value,value,value,value,value,value}
#define declareconstd(name,value) static const __m512d name = {value,value,value,value,value,value,value,value}

// ops : 8
// flops : 13

#ifdef __MIC__

struct bival
{
	__m512 x, y ;	
} ;

struct bivald
{
	__m512d x, y ;
} ;

struct quadval
{
	__m512 x, y, z, w ;	
} ;

struct quadvald
{
	__m512d x, y, z, w ;
} ;

__attribute__((target(mic))) inline bival myexpm1V (bival a)
{
	// static const __m512 v0 = { 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f } ;
	declareconst(v0, 8.0f) ;
	declareconst(v1, 56.0f) ;
	declareconst(v2, 336.0f) ;
	declareconst(v3, 1680.0f) ;
	declareconst(v4, 6720.0f) ;
	declareconst(v5, 20160.0f) ;
	declareconst(v6, 2.4801587301587301587301587301587e-5f) ;
	
	bival res ;
	res.x = _mm512_add_ps (a.x, v0) ;
	res.y = _mm512_add_ps (a.y, v0) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v1) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v1) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v2) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v2) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v3) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v3) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v4) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v4) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v5) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v5) ;
	res.x = _mm512_mul_ps (_mm512_mul_ps (res.x, a.x), v6) ;
	res.y = _mm512_mul_ps (_mm512_mul_ps (res.y, a.y), v6) ;
	return res ;
}

__attribute__((target(mic))) inline bivald myexpm1Vd (bivald a)
{
	// static const __m512 v0 = { 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f } ;
	declareconstd(v0, 8.0) ;
	declareconstd(v1, 56.0) ;
	declareconstd(v2, 336.0) ;
	declareconstd(v3, 1680.0) ;
	declareconstd(v4, 6720.0) ;
	declareconstd(v5, 20160.0) ;
	declareconstd(v6, 2.4801587301587301587301587301587e-5) ;
	
	bivald res ;
	res.x = _mm512_add_pd (a.x, v0) ;
	res.y = _mm512_add_pd (a.y, v0) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v1) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v1) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v2) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v2) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v3) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v3) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v4) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v4) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v5) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v5) ;
	res.x = _mm512_mul_pd (_mm512_mul_pd (res.x, a.x), v6) ;
	res.y = _mm512_mul_pd (_mm512_mul_pd (res.y, a.y), v6) ;
	return res ;
}

__attribute__((target(mic))) inline quadval myexpm1V (const quadval& a)
{
	// static const __m512 v0 = { 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f } ;
	declareconst(v0, 8.0f) ;
	declareconst(v1, 56.0f) ;
	declareconst(v2, 336.0f) ;
	declareconst(v3, 1680.0f) ;
	declareconst(v4, 6720.0f) ;
	declareconst(v5, 20160.0f) ;
	declareconst(v6, 2.4801587301587301587301587301587e-5f) ;
	
	quadval res ;
	res.x = _mm512_add_ps (a.x, v0) ;
	res.y = _mm512_add_ps (a.y, v0) ;
	res.z = _mm512_add_ps (a.z, v0) ;
	res.w = _mm512_add_ps (a.w, v0) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v1) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v1) ;
	res.z = _mm512_fmadd_ps (res.z, a.z, v1) ;
	res.w = _mm512_fmadd_ps (res.w, a.w, v1) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v2) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v2) ;
	res.z = _mm512_fmadd_ps (res.z, a.z, v2) ;
	res.w = _mm512_fmadd_ps (res.w, a.w, v2) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v3) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v3) ;
	res.z = _mm512_fmadd_ps (res.z, a.z, v3) ;
	res.w = _mm512_fmadd_ps (res.w, a.w, v3) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v4) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v4) ;
	res.z = _mm512_fmadd_ps (res.z, a.z, v4) ;
	res.w = _mm512_fmadd_ps (res.w, a.w, v4) ;
	res.x = _mm512_fmadd_ps (res.x, a.x, v5) ;
	res.y = _mm512_fmadd_ps (res.y, a.y, v5) ;
	res.z = _mm512_fmadd_ps (res.z, a.z, v5) ;
	res.w = _mm512_fmadd_ps (res.w, a.w, v5) ;
	res.x = _mm512_mul_ps (_mm512_mul_ps (res.x, a.x), v6) ;
	res.y = _mm512_mul_ps (_mm512_mul_ps (res.y, a.y), v6) ;
	res.z = _mm512_mul_ps (_mm512_mul_ps (res.z, a.z), v6) ;
	res.w = _mm512_mul_ps (_mm512_mul_ps (res.w, a.w), v6) ;
	return res ;
}

__attribute__((target(mic))) inline quadvald myexpm1Vd (const quadvald& a)
{
	// static const __m512 v0 = { 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f, 8.0f } ;
	declareconstd(v0, 8.0) ;
	declareconstd(v1, 56.0) ;
	declareconstd(v2, 336.0) ;
	declareconstd(v3, 1680.0) ;
	declareconstd(v4, 6720.0) ;
	declareconstd(v5, 20160.0) ;
	declareconstd(v6, 2.4801587301587301587301587301587e-5) ;
	
	quadvald res ;
	res.x = _mm512_add_pd (a.x, v0) ;
	res.y = _mm512_add_pd (a.y, v0) ;
	res.z = _mm512_add_pd (a.z, v0) ;
	res.w = _mm512_add_pd (a.w, v0) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v1) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v1) ;
	res.z = _mm512_fmadd_pd (res.z, a.z, v1) ;
	res.w = _mm512_fmadd_pd (res.w, a.w, v1) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v2) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v2) ;
	res.z = _mm512_fmadd_pd (res.z, a.z, v2) ;
	res.w = _mm512_fmadd_pd (res.w, a.w, v2) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v3) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v3) ;
	res.z = _mm512_fmadd_pd (res.z, a.z, v3) ;
	res.w = _mm512_fmadd_pd (res.w, a.w, v3) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v4) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v4) ;
	res.z = _mm512_fmadd_pd (res.z, a.z, v4) ;
	res.w = _mm512_fmadd_pd (res.w, a.w, v4) ;
	res.x = _mm512_fmadd_pd (res.x, a.x, v5) ;
	res.y = _mm512_fmadd_pd (res.y, a.y, v5) ;
	res.z = _mm512_fmadd_pd (res.z, a.z, v5) ;
	res.w = _mm512_fmadd_pd (res.w, a.w, v5) ;
	res.x = _mm512_mul_pd (_mm512_mul_pd (res.x, a.x), v6) ;
	res.y = _mm512_mul_pd (_mm512_mul_pd (res.y, a.y), v6) ;
	res.z = _mm512_mul_pd (_mm512_mul_pd (res.z, a.z), v6) ;
	res.w = _mm512_mul_pd (_mm512_mul_pd (res.w, a.w), v6) ;
	return res ;
}


#endif

#pragma offload_attribute(pop)

#pragma offload_attribute(push, target(mic))
#include <omp.h>
#pragma offload_attribute(pop)

__attribute__((target(mic))) void expkernel(int size, const float* __restrict a, float* __restrict c)
{
	#ifdef __MIC__
	#pragma omp parallel for 
	#pragma simd
	for (int k = 0 ; k < size ; ++k)
	{
		c[k] = myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(a[k])))))))))))) ;
	}
	#else
	#endif
}

__attribute__((target(mic))) void expkerneldouble(int size, const double* a, double* c)
{
	#ifdef __MIC__
	#pragma omp parallel for 
	#pragma simd
	for (int k = 0 ; k < size ; ++k)
	{
		c[k] = myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(myexpm1d(a[k])))))))))))) ;
	}
	#else
	#endif
}

__attribute__((target(mic))) int expkernel_hand_omp(int size, const float* __restrict a, float* c)
{
	#ifdef __MIC__
	#pragma omp parallel
	{
		int startK = omp_get_thread_num() * (size/32) / omp_get_max_threads() ;
		int endK = (1 + omp_get_thread_num()) * (size/32) / omp_get_max_threads() ;
		#pragma noprefetch
		for (int k = startK ; k < endK ; ++k)
		{
			bival ct ;
			ct.x = _mm512_load_ps ((void*)(a + 32 * k)) ;
			ct.y = _mm512_load_ps ((void*)(a + 32 * k + 16)) ;
			ct = myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(ct)))))))))))) ;
			_mm512_storenrngo_ps ((void*)(c + 32 * k), ct.x) ;
			_mm512_storenrngo_ps ((void*)(c + 32 * k + 16), ct.y) ;
			_mm_prefetch ((const char*)&a[32*(k+1)]     , _MM_HINT_T0) ;
			_mm_prefetch ((const char*)&a[32*(k+1)+16]     , _MM_HINT_T0) ;
			_mm_prefetch ((const char*)&a[32*(k+8)]     , _MM_HINT_T1) ;
			_mm_prefetch ((const char*)&a[32*(k+8)+16]     , _MM_HINT_T1) ;
		}
	}
	return omp_get_num_threads() ;
	#else
	return -1;
	#endif
}

__attribute__((target(mic))) int expkernel_hand_ompdouble(int size, const double* __restrict a, double* c)
{
	#ifdef __MIC__
	#pragma omp parallel
	{
		int startK = omp_get_thread_num() * (size/16) / omp_get_max_threads() ;
		int endK = (1 + omp_get_thread_num()) * (size/16) / omp_get_max_threads() ;
		#pragma noprefetch
		for (int k = startK ; k < endK ; ++k)
		{
			bivald ct;
			ct.x = _mm512_load_pd ((void*)(a + 16 * k)) ;
			ct.y = _mm512_load_pd ((void*)(a + 16 * k + 8)) ;
			ct = myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(myexpm1Vd(ct)))))))))))) ;
			_mm512_storenrngo_pd ((void*)(c + 16 * k), ct.x) ;
			_mm512_storenrngo_pd ((void*)(c + 16 * k + 8), ct.y) ;
			_mm_prefetch ((const char*)&a[16*(k+1)]     , _MM_HINT_T0) ;
			_mm_prefetch ((const char*)&a[16*(k+1)+8]     , _MM_HINT_T0) ;
			_mm_prefetch ((const char*)&a[16*(k+8)]     , _MM_HINT_T1) ;
			_mm_prefetch ((const char*)&a[16*(k+8)+8]     , _MM_HINT_T1) ;
		}
	}
	return omp_get_num_threads() ;
	#else
	return -1;
	#endif
}


#pragma offload_attribute(push,target(mic))
#define forceinlineexp(v0,v1,v2,v3,v4,v5,v6,x) _mm512_mul_ps (_mm512_mul_ps (_mm512_fmadd_ps (_mm512_fmadd_ps (_mm512_fmadd_ps (_mm512_fmadd_ps (_mm512_fmadd_ps (_mm512_add_ps (x, v0), x, v1), x, v2), x, v3), x, v4), x, v5) , x), v6) 

__attribute__((target(mic))) int expkernel_forceinline(int size, const float* a, float* c)
{
	#ifdef __MIC__
	declareconst(v0, 8.0f) ;
	declareconst(v1, 56.0f) ;
	declareconst(v2, 336.0f) ;
	declareconst(v3, 1680.0f) ;
	declareconst(v4, 6720.0f) ;
	declareconst(v5, 20160.0f) ;
	declareconst(v6, 2.4801587301587301587301587301587e-5f) ;
	
	#pragma omp parallel
	{
		int startK = omp_get_thread_num() * (size/16) / omp_get_num_threads() ;
		int endK = (1 + omp_get_thread_num()) * (size/16) / omp_get_num_threads() ;
		__m512i index, baseindex, increment ;
		baseindex = _mm512_set_epi32(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
		index = _mm512_set1_epi32(16*startK);
		index = _mm512_add_epi32 (index, baseindex) ;
		increment = _mm512_set1_epi32(16);
		for (int k = startK ; k < endK ; ++k)
		{
			__m512 ct = _mm512_i32gather_ps (index, a, sizeof (float)) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexp (v0,v1,v2,v3,v4,v5,v6,ct) ;
			// ct = myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(myexpm1V(ct)))))))))))) ;
			_mm512_i32scatter_ps (c, index, ct, sizeof (float)) ;
			index = _mm512_add_epi32 (index, increment) ;
		}
	}
	return omp_get_num_threads() ;
	#else
	return -1;
	#endif
}

#define forceinlineexpd(v0,v1,v2,v3,v4,v5,v6,x) _mm512_mul_pd (_mm512_mul_pd (_mm512_fmadd_pd (_mm512_fmadd_pd (_mm512_fmadd_pd (_mm512_fmadd_pd (_mm512_fmadd_pd (_mm512_add_pd (x, v0), x, v1), x, v2), x, v3), x, v4), x, v5) , x), v6) 

__attribute__((target(mic))) int expkernel_forceinlinedouble(int size, const double* a, double* c)
{
	#ifdef __MIC__
	declareconstd(v0, 8.0) ;
	declareconstd(v1, 56.0) ;
	declareconstd(v2, 336.0) ;
	declareconstd(v3, 1680.0) ;
	declareconstd(v4, 6720.0) ;
	declareconstd(v5, 20160.0) ;
	declareconstd(v6, 2.4801587301587301587301587301587e-5) ;
	
	#pragma omp parallel
	{
		int startK = omp_get_thread_num() * (size/8) / omp_get_num_threads() ;
		int endK = (1 + omp_get_thread_num()) * (size/8) / omp_get_num_threads() ;
		__m512i index, baseindex, increment ;
		baseindex = _mm512_set_epi32(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
		index = _mm512_set1_epi32(8*startK);
		index = _mm512_add_epi32 (index, baseindex) ;
		increment = _mm512_set1_epi32(8);
		for (int k = startK ; k < endK ; ++k)
		{
			__m512d ct = _mm512_i32logather_pd (index, a, sizeof (double)) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;
			ct = forceinlineexpd (v0,v1,v2,v3,v4,v5,v6,ct) ;

			_mm512_i32loscatter_pd (c, index, ct, sizeof (double)) ;
			index = _mm512_add_epi32 (index, increment) ;
		}
	}
	return omp_get_num_threads() ;
	#else
	return -1;
	#endif
}
#pragma offload_attribute(pop)

struct timer
{
	struct timeval _start ;
	struct timeval _stop ;

	void start ()
	{
		::gettimeofday (&_start, 0) ;
	}
	void stop ()
	{
		::gettimeofday (&_stop, 0) ;
	}
	double duration ()
	{
		return (((double)_stop.tv_usec - (double)_start.tv_usec) * 1.0e-6) +
		(double)_stop.tv_sec - (double)_start.tv_sec ;
	}
} ;

void* memalign(int align, int size)
{
	char* tmp = (char*) ::malloc (size + align) ;
	size_t itmp = (size_t) tmp ;
	itmp = (itmp + align -1) & (~(align-1));
	return (void*) itmp ;
}

#define ALLOC   alloc_if(1)
#define FREE    free_if(1)
#define RETAIN  free_if(0)
#define REUSE   alloc_if(0)

int main(int argc, char* argv[])
{
	timer inner, outer ;	
	int redocount = 100 ;
	int size = 1024*240*1024 ;
	float* a = (float*)memalign(64, size * sizeof (float)) ;
	float* c = (float*)memalign(64, size * sizeof (float)) ;
	double* da = (double*)memalign(64, size * sizeof (double)) ;
	double* dc = (double*)memalign(64, size * sizeof (double)) ;
	for (int k = 0 ; k < size ; ++k)
	{
		a [k] = 1.0f / (4.0f + (float)k) ;
		c [k] = 0.0f ;
		da [k] = 1.0 / (4.0 + (double)k) ;
		dc [k] = 0.0 ;
	}

	outer.start();
	
	// copy/alloc to device
	#pragma offload target(mic:0) in(a:length(size) ALLOC RETAIN)
	{}
	#pragma offload target(mic:0) out(c:length(size) ALLOC RETAIN)
	{}
	#pragma offload target(mic:0) in(da:length(size) ALLOC RETAIN)
	{}
	#pragma offload target(mic:0) out(dc:length(size) ALLOC RETAIN)
	{}

	::fprintf (stderr, "[INFO] : blank run\n");
	#pragma offload target(mic:0) nocopy(a:length(size) REUSE RETAIN) nocopy(c:length(size) REUSE RETAIN) nocopy(da:length(size) REUSE RETAIN) nocopy(dc:length(size) REUSE RETAIN)
	{
		expkernel_forceinline (size, a, c) ;
		expkernel_hand_omp (size, a, c) ;
		expkernel (size, a, c) ;
		expkernel_forceinlinedouble (size, da, dc) ;
		expkernel_hand_ompdouble (size, da, dc) ;
		expkerneldouble (size, da, dc) ;
	}
	::fprintf (stderr, "[INFO] : starting inner\n");

	double tbase = 1e12 ;
	double tintrin = 1e12 ;
	double tforce = 1e12 ;
	double tdouble = 1e12 ;
	double tintrindouble = 1e12 ;
	double tforcedouble = 1e12 ;
	for (int k = 0 ; k < redocount ; ++k)
	{
		inner.start();
		#pragma offload target(mic:0) nocopy(a:length(size) REUSE RETAIN) nocopy(c:length(size) REUSE RETAIN)
		expkernel (size, a, c) ;
		inner.stop();
		if (tbase > inner.duration()) tbase = inner.duration () ;

		inner.start();
		#pragma offload target(mic:0) nocopy(a:length(size) REUSE RETAIN) nocopy(c:length(size) REUSE RETAIN)
		expkernel_forceinline (size, a, c) ;
		inner.stop();
		if (tforce > inner.duration()) tforce = inner.duration () ;

		inner.start();
		#pragma offload target(mic:0) nocopy(a:length(size) REUSE RETAIN) nocopy(c:length(size) REUSE RETAIN)
		expkernel_hand_omp (size, a, c) ;
		inner.stop();
		if (tintrin > inner.duration()) tintrin = inner.duration () ;

		inner.start();
		#pragma offload target(mic:0) nocopy(da:length(size) REUSE RETAIN) nocopy(dc:length(size) REUSE RETAIN)
		expkerneldouble (size, da, dc) ;
		inner.stop();
		if (tdouble > inner.duration()) tdouble = inner.duration () ;

		inner.start();
		#pragma offload target(mic:0) nocopy(da:length(size) REUSE RETAIN) nocopy(dc:length(size) REUSE RETAIN)
		expkernel_forceinlinedouble (size, da, dc) ;
		inner.stop();
		if (tforcedouble > inner.duration()) tforcedouble = inner.duration () ;

		inner.start();
		#pragma offload target(mic:0) nocopy(da:length(size) REUSE RETAIN) nocopy(dc:length(size) REUSE RETAIN)
		expkernel_hand_ompdouble (size, da, dc) ;
		inner.stop();
		if (tintrindouble > inner.duration()) tintrindouble = inner.duration () ;
	}


	::fprintf (stderr, "[INFO] : done inner\n");

	// copyback and free
	#pragma offload target(mic:0) nocopy(a:length(size) REUSE FREE) out(c:length(size) REUSE FREE)
	{}

	outer.stop();
	
	/*
	int counts [8] ;
	for (int j = 0 ; j < 8 ; ++j)
		counts [j] = 0 ;
	for (int k = 0 ; k < size ; ++k)
	{
		// float theo = ::expf(::expf(::expf(::expf(::expf(::expf(::expf(::expf(a[k])-1.0f)-1.0f)-1.0f)-1.0f)-1.0f)-1.0f)-1.0f)-1.0f ;
		float theo = myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(myexpm1(a[k])))))))))))) ;
		if (k < 64)
			::fprintf (stderr, "[%d] : theo %f -- computed %f\n", k, theo, c[k]) ;
		if (::fabsf (c [k] - theo) > 1.0e-0f * ::fabsf(theo))
			++counts[0] ;
		else if (::fabsf (c [k] - theo) > 1.0e-1f * ::fabsf(theo))
			++counts[1] ;
		else if (::fabsf (c [k] - theo) > 1.0e-2f * ::fabsf(theo))
			++counts[2] ;
		else if (::fabsf (c [k] - theo) > 1.0e-3f * ::fabsf(theo))
			++counts[3] ;
		else if (::fabsf (c [k] - theo) > 1.0e-4f * ::fabsf(theo))
			++counts[4] ;
		else if (::fabsf (c [k] - theo) > 1.0e-5f * ::fabsf(theo))
			++counts[5] ;
		else if (::fabsf (c [k] - theo) > 1.0e-6f * ::fabsf(theo))
			++counts[6] ;
		else if (::fabsf (c [k] - theo) > 1.0e-7f * ::fabsf(theo))
			++counts[7] ;
	}
	::fprintf (stderr, "Error report : > 1.0000000 : %d\n", counts[0]) ;
	::fprintf (stderr, "Error report : > 0.1000000 : %d\n", counts[1]) ;
	::fprintf (stderr, "Error report : > 0.0100000 : %d\n", counts[2]) ;
	::fprintf (stderr, "Error report : > 0.0010000 : %d\n", counts[3]) ;
	::fprintf (stderr, "Error report : > 0.0001000 : %d\n", counts[4]) ;
	::fprintf (stderr, "Error report : > 0.0000100 : %d\n", counts[5]) ;
	::fprintf (stderr, "Error report : > 0.0000010 : %d\n", counts[6]) ;
	::fprintf (stderr, "Error report : > 0.0000001 : %d\n", counts[7]) ;
	::fprintf (stderr, "Took %lf seconds [%lf]\n", t, outer.duration()) ; */
	double totalexps = (double)size * 12.0 ;
	::fprintf (stderr, "myexpm1 per ns = %lf \n", totalexps / tbase / 1000000000.0) ;
	//number of operations
	double flopcount = 13.0*totalexps;
	double opcount = 8.0*totalexps;
	::fprintf (stderr, "[float:base]GFLOPS = %4.0lf \n", flopcount / tbase / 1000000000.0) ;
	::fprintf (stderr, "[float:base]GFMOPS = %4.0lf \n", opcount / tbase / 1000000000.0) ;
	::fprintf (stderr, "[float:intrin]GFLOPS = %4.0lf \n", flopcount / tintrin / 1000000000.0) ;
	::fprintf (stderr, "[float:intrin]GFMOPS = %4.0lf \n", opcount / tintrin / 1000000000.0) ;
	::fprintf (stderr, "[float:force]GFLOPS = %4.0lf \n", flopcount / tforce / 1000000000.0) ;
	::fprintf (stderr, "[float:force]GFMOPS = %4.0lf \n", opcount / tforce / 1000000000.0) ;
	::fprintf (stderr, "[double:base]GFLOPS = %4.0lf \n", flopcount / tdouble / 1000000000.0) ;
	::fprintf (stderr, "[double:base]GFMOPS = %4.0lf \n", opcount / tdouble / 1000000000.0) ;
	::fprintf (stderr, "[double:intrin]GFLOPS = %4.0lf \n", flopcount / tintrindouble / 1000000000.0) ;
	::fprintf (stderr, "[double:intrin]GFMOPS = %4.0lf \n", opcount / tintrindouble / 1000000000.0) ;
	::fprintf (stderr, "[double:force]GFLOPS = %4.0lf \n", flopcount / tforcedouble / 1000000000.0) ;
	::fprintf (stderr, "[double:force]GFMOPS = %4.0lf \n", opcount / tforcedouble / 1000000000.0) ;
	return 0 ;
}

